<template>
  <!-- <mu-select
        label="Drum Sound"
        v-model="chosenDrumType"
        full-width
        @change="onInputChosenDrumType"
      >
        <mu-option
          v-for="option in DrumTypes"
          :key="option"
          :label="option"
          :value="option"
        ></mu-option>
      </mu-select> -->
  <!-- </mu-expansion-panel> -->
  <mu-container>
    <mu-card :class="'p-1 my-1 ' + (showBeat ? 'show-flash' : '')">
      <h2 class="m-0 mb-1">{{ chosenDrumType }}</h2>
      <div class="mb-1" style="height: 3em;">
        <strong>Piezo Sensor Pin:</strong> {{ sensor }}
        <br />
        <div v-if="pedalSensor !== undefined">
          <strong>Pedal Sensor Pin:</strong> {{ pedalSensor }}
        </div>
      </div>
      <strong>Volume:</strong>
      <mu-slider
        class="demo-slider mb-1"
        color="success"
        v-model="volume"
        @change="onInputVolume"
        :min="10"
        :max="100"
      ></mu-slider>
      <strong>Minimum signal:</strong>
      <mu-slider
        class="demo-slider mb-1"
        color="secondary"
        v-model="threshold"
        @change="onInputThreshold"
        :max="1024"
      ></mu-slider>
      <div ref="inputGraph" class="mb-2"></div>

      <strong>Cool Down:</strong>
      <mu-slider
        class="demo-slider mb-1"
        v-model="coolDown"
        @change="onInputCoolDown"
        :max="250"
      ></mu-slider>
      <div ref="outputGraph"></div>
    </mu-card>
  </mu-container>
</template>
<style lang="scss" scoped>
.mu-card {
  border: 8px solid #e91e6300;
  border-radius: 8px;
  transition: 400ms;
  &.show-flash {
    transition: 100ms;
    border: 8px solid #e91e63;
  }
}
</style>
<script lang="ts">
const trace = console.log.bind(this);

import { defineComponent, ref, PropOptions } from "@vue/composition-api";
import { DrumKitPlayer, DrumTypes } from "../DrumKitPlayer";
import { makeLocalStorageable } from "../MyUtil";
import { onMounted, SetupContext } from "@vue/composition-api";
import { Data } from "@vue/composition-api/dist/component";
import CustomCanvas from "./CustomCanvas";
interface DataSensorReading {
  sensorReading: number;
  timeStamp: number;
}
export default defineComponent({
  props: {
    sensor: String,
    pedalSensor: String,
    drum: String,
    socket: Object,
  },
  setup(p: any, context: any) {
    const showBeat = ref(false);
    const {
      refValue: chosenDrumType,
      onInput: onInputChosenDrumType,
    } = makeLocalStorageable("chosenDrumType" + p.drum, p.drum as DrumTypes);

    const {
      refValue: threshold,
      onInput: onInputThreshold,
    } = makeLocalStorageable("threshold" + p.drum, 50);

    const { refValue: volume, onInput: onInputVolume } = makeLocalStorageable(
      "volume" + p.drum,
      20
    );
    const {
      refValue: thresholdB,
      onInput: onInputThresholdB,
    } = makeLocalStorageable("thresholdB" + p.drum, 0);
    const {
      refValue: coolDown,
      onInput: onInputCoolDown,
    } = makeLocalStorageable("coolDown" + p.drum, 100);

    onMounted(() => {
      const drumKitPlayer = new DrumKitPlayer();

      function checkForKnock(
        wasUp: boolean,
        prevData: DataSensorReading,
        data: DataSensorReading,
        threshold: number,
        thresholdB: number,
        lastKnockTime: number
      ) {
        let diff = data.sensorReading - prevData.sensorReading;

        if (
          data.sensorReading > threshold &&
          diff > thresholdB &&
          wasUp === false &&
          data.timeStamp - lastKnockTime >= coolDown.value
        ) {
          return 1;
        }
        return 0;
      }

      let wasUp = false;
      let lastKnockTime = 0;
      let sen = p.sensor || "";
      let pedalSensor = p.pedalSensor || "";
      let prevData: DataSensorReading = { sensorReading: 0, timeStamp: 0 };
      let isPedalDown = false;
      
      p.socket.on(pedalSensor, (sensorReading: number) => {
        if (sensorReading > 512) {
          isPedalDown = false;
        } else {
          isPedalDown = true;
        }
      });
      p.socket.on(sen, (sensorReading: number) => {
        let timeStamp = new Date().getTime();
        const data = { sensorReading: sensorReading, timeStamp: timeStamp };
        const wasKnocked = checkForKnock(
          wasUp,
          prevData,
          data,
          threshold.value,
          thresholdB.value,
          lastKnockTime
        );
        addToData(data);

        if (wasKnocked > 0) {
          wasUp = true;
          lastKnockTime = timeStamp;
          trace("hit");
          showBeat.value = true;
          setTimeout(() => {
            showBeat.value = false;
          }, 100);
          drumKitPlayer.setVolume(volume.value / 100);
          if (p.drum === DrumTypes.HiHat) {
            if (!isPedalDown) {
              drumKitPlayer.play(DrumTypes.HiHatClosed as DrumTypes);
            } else {
              drumKitPlayer.play(DrumTypes.HiHatOpen as DrumTypes);
            }
          } else {
            drumKitPlayer.play(p.drum as DrumTypes);
          }
        } else {
          wasUp = false;
        }
        prevData = data;
      });

      p.socket.on("connect", function() {
        console.log("connected");
      });

      p.socket.on("disconnect", function() {
        console.log("disconnected");
      });
      p.socket.on("board-event", (m: string) => {
        trace("test", m);
      });

      let dataArray: DataSensorReading[] = [];
      // const height = 146;
      // const width = 328;
      let gridSize = 4;
      let maxData: number = 328 / gridSize;
      let bgGridSize = 100;
      let addedCount: number = 0;

      let highest = 1024;

      function addToData(data: DataSensorReading) {
        const index = Math.floor(addedCount % maxData);
        dataArray[index] = data;
        if (data.sensorReading > highest) {
          highest = data.sensorReading;
        }
        addedCount++;
      }

      const yellow = "rgb(244, 200, 2)";
      const pink = "#ff4081";
      const orange = "rgb(244, 100, 2)";
      // const t = "rgba(244, 200, 2, 128)";
      const grey = "rgba(0, 0, 0, 1)";
      const blue = "#2196f3";
      const sketch = (ctx: CanvasRenderingContext2D, p: CustomCanvas) => {
        ctx.clearRect(0, 0, p.canvas.width, p.canvas.height);
        ctx.lineWidth = 1;
        let height = p.canvas.height;
        let width = p.canvas.width;
        maxData = width / gridSize;
        // trace(p.canvas)
        ctx.strokeStyle = grey;
        let index = Math.floor(addedCount % maxData);
        for (
          var y = 0;
          y < height;
          y += (gridSize * bgGridSize) / (highest * 0.01)
        ) {
          p.line(0, height - y, width, height - y);
          break;
        }
        for (var x = 0; x < width; x += gridSize * bgGridSize) {
          p.line(x, 0, x, height);
          break;
        }

        function calcPoint(v: number) {
          return height - (v / highest) * height;
        }

        ctx.strokeStyle = pink;
        p.line(
          0,
          calcPoint(threshold.value),
          width,
          calcPoint(threshold.value)
        );

        ctx.strokeStyle = yellow;
        for (var i = 0; i < dataArray.length - 1; i++) {
          p.line(
            i * gridSize,
            calcPoint(dataArray[i].sensorReading),
            (i + 1) * gridSize,
            calcPoint(dataArray[i + 1].sensorReading)
          );
        }

        // p.stroke();
        // p.line(index * gridSize, 0, index * gridSize, height);
      };

      const sketch2 = (ctx: CanvasRenderingContext2D, p: CustomCanvas) => {
        let highest = 4;
        let height = p.canvas.height;
        let width = p.canvas.width;
        ctx.clearRect(0, 0, width, height);

        ctx.strokeStyle = grey;
        for (var y = 0; y < height; y += gridSize * bgGridSize) {
          p.line(0, height - y, width, height - y);
          break;
        }
        for (var x = 0; x < width; x += gridSize * bgGridSize) {
          p.line(x, 0, x, height);
          break;
        }

        function calcPoint(v: number) {
          return height - (v / highest) * height;
        }

        function calcPointX(v: number) {
          return Math.round(v / 5);
        }

        ctx.strokeStyle = blue;
        for (var x = 14; x < width; x += gridSize * bgGridSize) {
          p.line(
            calcPointX(coolDown.value),
            0,
            calcPointX(coolDown.value),
            height
          );
        }
        var wasUp = false;
        let lastKnockTime = 0;
        var old = 0;
        for (var i = 0; i < dataArray.length - 1; i++) {
          let t = checkForKnock(
            wasUp,
            dataArray[i + 1],
            dataArray[i],
            threshold.value,
            thresholdB.value,
            lastKnockTime
          );
          if (t > 0) {
            wasUp = true;
            lastKnockTime = dataArray[i].timeStamp;
          } else {
            wasUp = false;
          }

          ctx.strokeStyle = yellow;
          p.line(
            i * gridSize,
            calcPoint(old),
            (i + 1) * gridSize,
            calcPoint(t)
          );
          old = t;
        }
      };

      if (context.refs.hasOwnProperty("inputGraph")) {
        new CustomCanvas(sketch, context.refs.inputGraph as HTMLElement);
      }
      if (context.refs.hasOwnProperty("outputGraph")) {
        new CustomCanvas(sketch2, context.refs.outputGraph as HTMLElement);
      }
    });
    return {
      threshold,
      thresholdB,
      coolDown,
      onInputThreshold,
      onInputThresholdB,
      onInputCoolDown,
      DrumTypes,
      chosenDrumType,
      onInputChosenDrumType,
      showBeat,
      volume,
      onInputVolume,
    };
  },
});
</script>
